
#include "stdafx.h"

#include <wx/aui/aui.h>

#include "Aui.h"
#include "Main.h"
#include "Thread.h"

Aui::Aui()
:wxAuiManager()
{
}

Aui::Aui(wxWindow *window)
:wxAuiManager(window)
{
}

void Aui::init()
{
	unsigned int flags = GetFlags();
	flags &= ~wxAUI_MGR_TRANSPARENT_HINT;
	flags &= ~wxAUI_MGR_VENETIAN_BLINDS_HINT;
	flags &= ~wxAUI_MGR_RECTANGLE_HINT;
	flags|=
		  wxAUI_MGR_ALLOW_FLOATING
		| wxAUI_MGR_NO_VENETIAN_BLINDS_FADE
		| wxAUI_MGR_ALLOW_ACTIVE_PANE
		| wxAUI_MGR_TRANSPARENT_HINT
		| wxAUI_MGR_RECTANGLE_HINT;
	SetFlags(flags);

	wxAuiDockArt *art=GetArtProvider();
	int i=art->GetMetric(wxAUI_DOCKART_CAPTION_SIZE);
	art->SetMetric(wxAUI_DOCKART_CAPTION_SIZE, int(i*0.7));
}

Aui::~Aui()
{
}

void Aui::Update()
{
	wxAuiManager::Update();
//	Thread::This()->dispatchMessages();
}
