
#ifndef WIN32
struct COORD {int X,Y;};
#endif

class Consolew: public wxFrame
{
public:
#ifdef WIN32
	void *kernel32;
	WINDOWPLACEMENT consoleWP;
	HANDLE hConsoleInput, hConsoleOutput;
	HWND hwnd;

	typedef HWND (WINAPI *TGetConsoleWindow) (void);
	TGetConsoleWindow GetConsoleWindow;
#else
//	TODO
	int hwnd;
#endif
	COORD coord, coord0;
	bool lineAvailable, charAvailable, charMode;
	char ch;
	unsigned int readIndex, pos, chExt;
	wxString readLine, oldReadLine;

	Consolew();
	~Consolew();

	void show(int state);
	void SetFocus();
	wxPoint GetPosition();
	wxSize GetSize();
	NodeP _Cursor();
	NodeP _setCursor(PairP arg);
	NodeP _setTextColor(PairPP arg);
	void SetInsertionCoord(int x, int y);
	void ClientToScreen(int *x, int *y);
	void WriteText(wxString str);
	void finishLine(wxString str);
	void charModeOn();
	void charModeOff();
	bool kbhit();
	char getch();
	int getchExt();
	char getc();

	void OnChar(wxKeyEvent &ev);
	void OnKeyDown(wxKeyEvent &ev);
	void OnKeyUp(wxKeyEvent &ev);

	DECLARE_EVENT_TABLE()
};

extern Consolew *consolew;
