#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Int8_included

class Int8: public Node
{
	public: 
		char int_;
		static const char digits;
		static const char min;
		static const char max;
		static const Int8 aInt8;

		operator_new;
		Int8():       Node(NINT8), int_(0) {}
		Int8(char i): Node(NINT8), int_(i) {}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP   string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		int   numberP() {return 1;}
		double getnumber() {return int_;}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP reverse();
		NodeP readbin(FileP file);
		NodeP upper();
		NodeP lower();
		PairP list();

		static char clip(double d);
		static char clip(int i);
};

	#define Int8_included
#endif
