#ifndef IntNodeTable_included

class IntNodeTable
{
	public:
		class IntNodePair;
		typedef IntNodePair *IntNodePairP;

		class IntNodePair
		{
		public:
			int i;
			NodeP nd;
			IntNodePairP tail;

			IntNodePair(int i_, NodeP nd_, IntNodePairP tail_):
				i(i_), nd(nd_), tail(tail_)
			{}

			~IntNodePair() {if (tail) delete tail;}
		};

		int size;
		IntNodePairP *data;

		IntNodeTable() {}
		IntNodeTable(int size_);
		virtual ~IntNodeTable();

		int hash(int i);
		IntNodePairP find(int i);
		IntNodePairP insert(int i, NodeP nd);

		int item(int index);
		void setitem(int index, NodeP newitem);
		void removeitem(int index);
};
typedef IntNodeTable *IntNodeTableP;

	#define IntNodeTable_included
#endif
