
class ToDoStack
{
	public:
		struct Item
		{	ToDo i;
#ifdef SDEBUG
			EvalStackMarker marker;
			charP name;
			int line;
#endif
		};
		typedef Item *ItemP;

		int item, maxitem;
		int size;

		union
		{	ItemP base;
			ItemP (*base100)[100];
		};
		ItemP index, max;

		ToDoStack();
		~ToDoStack();

		bool grow();
		bool shrink();
#ifdef SDEBUG		
		void push(ToDo val), 
			push(ToDo val, EvalStackMarker marker, charP name, int line), 
			pop(ToDo &val, EvalStackMarker marker);
/*		ToDoStack 
			&operator<<(const ToDo val),
			&operator>>(ToDo &val);
*/
#else
	void push(const ToDo val) 
	{	if (index+2 > max)
			if (!grow())
				return;
		(++index)->i=val;
		return;
	}
	ToDoStack &operator<<(const ToDo val) 
	{	if (index+2 > max)
			if (!grow())
				return *this;
		(++index)->i=val;
		return *this;
	}
	void pop(ToDo &val) {val = (index--)->i;}
#endif
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};

