class StackVars: public wxListCtrl
{
	public:
		volatile bool inupdate;
		int count;
		wxArrayString namearr, valarr;
		wxArrayPtrVoid objarr;

		StackVars(wxWindow* parent, wxWindowID id, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxSize(200,200), 
			long style = wxLC_REPORT | wxLC_VIRTUAL, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("StackVars"));

		~StackVars();

		void show(bool shown=true);
		wxString OnGetItemText(long item, long column) const;
		void OnClick(wxListEvent &ev);
		void update();

		DECLARE_EVENT_TABLE()
};

class Vars: public wxListCtrl
{
	public:
		volatile bool inupdate;
		int count;
		wxArrayString namearr, valarr;
		wxArrayPtrVoid objarr;

		Vars(wxWindow* parent, wxWindowID id, 
			const wxPoint& pos = wxDefaultPosition, 
			const wxSize& size = wxSize(200,200), 
			long style = wxLC_REPORT | wxLC_VIRTUAL, 
			const wxValidator& validator = wxDefaultValidator, 
			const wxString& name = _("Vars"));

		~Vars();

		void show(bool shown=true);
		wxString OnGetItemText(long item, long column) const;
		void OnClick(wxListEvent &ev);
		void branch(PairP tree, int &y, int level);
		void update();

		DECLARE_EVENT_TABLE()
};

extern Function lupdateVars, lupdateVarsOnStep;

extern bool updateVarsOnStep;
