
#include <wx/dde.h>
#include <wx/ipc.h>

class Connection: public wxDDEConnection
{
public:
};

class Client: public wxClient
{
public:
	wxConnectionBase *OnMakeConnection();
};

wxConnectionBase *Client::OnMakeConnection()
{
	Connection *con=new Connection;
	return con;
}

int __cdecl main(int argc, char **argv)
{
	Client *client=new Client;
	Connection *con=0;
	wxString host="localhost", 
		service="C:/temp/aucblogo.service", 
		topic="mytopic";
	while (!con)
		con=(Connection*)client->MakeConnection(host, service, topic);
	if (con)
	{	while (!con->Poke("request_method", getenv("request_method")))
			;
		while (!con->Poke("query_string", getenv("query_string")))
			;
		while (!con->Poke("content_length", getenv("content_length")))
			;
		wxString item="output ", name=argv[1];
		name=name.BeforeLast('.').AfterLast('/');
		char *result=0;
		while (!result)
			result=con->Request(item+name, 0, wxIPC_TEXT);
		if (result)
		{	int l=strlen(result);
			fwrite(result, l, 1, stdout);
		}
		delete con;
	}
	delete client;
	return 0;
}
