#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Int16_included

class Int16: public Node
{
	public: 
		int16 int_;
		static const int16 digits;
		static const int16 min;
		static const int16 max;
		static const Int16 aInt16;

		operator_new;
		Int16():        Node(NINT16), int_(0) {}
		Int16(int16 i): Node(NINT16), int_(i) {}

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP   string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		int   numberP() {return 1;}
		double getnumber() {return int_;}
		 NodeP    number() {return this;}

		OPERATORS_DECL
		NodeP compare(NodeP nd);
		int _sizeof();
		StringP _typeof();
		double _min(double d);
		double _max(double d);
		NodeP Norm();
		NodeP maxNorm();
		NodeP item(NodeP index, NodeP result);
		NodeP bititem(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		NodeP memberP(NodeP subobj, bool notp=false, bool substr=false);
		NodeP reverse();
		NodeP readbin(FileP file);
		NodeP upper();
		NodeP lower();
		PairP list();

		static int16 clip(double d);
		static int16 clip(int i);
};

	#define Int16_included
#endif
