
class IntToPtr_
{
public:
	class PtrIntPair;
	typedef PtrIntPair *PtrIntPairP;

	class PtrIntPair
	{
	public:
		int i;
		void *p;
		PtrIntPairP tail;

		PtrIntPair(void *p_, int i_, PtrIntPairP tail_):
			i(i_), p(p_), tail(tail_)
		{}

		~PtrIntPair() {if (tail) delete tail;}
	};

	int size, nr;
	PtrIntPairP *data;

	IntToPtr_(): size(0), nr(0), data(0) {}
	IntToPtr_(int size_);
	~IntToPtr_();

	int hash(int i);
	void *find(int i);
	PtrIntPairP findPair(int i);
	void insert(void *p);
	
	DataInputStream &readNodes(DataInputStream &istr);
};
