//___________________________________________________________________
//
//                          Class Piper
//
//       Execute a process and redirect its output to stdout. 
//                        Single-threaded!
//___________________________________________________________________

class Piper
{
	typedef void *HANDLE;
	typedef void *LPVOID;

	public:
		PairP output;
		Piper(const char *commandLine, bool wordmode_=false);

	protected:
		bool wordmode;
		static int bRunThread;
		static HANDLE hChildProcess, hStdIn; // Handle to parents std input.

		static void displayError(charP pszAPI);

		void
			readAndHandleOutput(HANDLE hPipeRead),

			prepAndLaunchRedirectedChild(const char *commandLine,
				HANDLE hChildStdOut, HANDLE hChildStdIn, HANDLE hChildStdErr);

		static unsigned long __stdcall getAndSendInputThread(LPVOID lpvThreadParam);
};
