#ifndef PtrNodeTable_included

class PtrNodeTable
{
	public:
		class PtrNodePair;
		typedef PtrNodePair *PtrNodePairP;

		class PtrNodePair
		{
		public:
			void *p;
			NodeP nd;
			PtrNodePairP tail;

			PtrNodePair(void *p_, NodeP nd_, PtrNodePairP tail_):
				p(p_), nd(nd_), tail(tail_)
			{}

			~PtrNodePair() {if (tail) delete tail;}
		};

		int size;
		PtrNodePairP *data;

		PtrNodeTable() {}
		PtrNodeTable(int size_);
		virtual ~PtrNodeTable();

		int hash(void *p);
		PtrNodePairP find(void *p);
		PtrNodePairP insert(void *p, NodeP nd);

		int item(void *index);
		void setitem(void *index, NodeP newitem);
		void removeitem(void *index);
};
typedef PtrNodeTable *PtrNodeTableP;

	#define PtrNodeTable_included
#endif
