#ifndef Table_included
	#include "Table.h"
#endif

#ifndef PtrTable_included

class PtrTable: public Table
{
	public:
		static const PtrTable aPtrTable;
		operator_new;

		PtrTable(): Table() {type=TABLE;}
		PtrTable(int size_);
		virtual ~PtrTable();
		void free();

		int hash(NodeP str);
		ObjectP find(NodeP str);
		ObjectP insert(NodeP nd);

		NodeP item(NodeP index);
		NodeP setitem(NodeP index, NodeP newitem);
		void removeitem(NodeP index);
};

	#define PtrTable_included
#endif
