//___________________________________________________________________
//
//                         BoxSizer Header
//___________________________________________________________________

extern Function 
	lStaticBoxSizer, lStaticBoxSizerDestroy;

class StaticBoxSizer: public wxStaticBoxSizer
{
	public:
		StaticBoxSizerNodeP boxSizerNode;
		wxString label;

		StaticBoxSizer(StaticBoxSizerNodeP boxSizerNode_, 
			int orient_, wxWindow *parent_, wxString label_);
		~StaticBoxSizer();

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef StaticBoxSizer *StaticBoxSizerP;

class StaticBoxSizerNode: public BoxSizerNode
{
	public:
		static const StaticBoxSizerNode aStaticBoxSizerNode;

		operator_new;

		StaticBoxSizerNode();

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void aftersetPtrs2();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();

		void bigSwitch(NodeP arg, wxWindow *&win, wxSizer *&sizer);
		NodeP bigArgSwitch(NodeP arg, wxWindow *&win, wxSizer *&sizer);
};
