#ifndef Node_included
	#include "Node.h"
#endif

class Turtle;

class TurtleNode: public Node
{
	public:
		Turtle *turtle;
		GraphNodeP graphNode;
		ArrayP shapes;

		static const TurtleNode aTurtleNode;

		operator_new;
		TurtleNode(): Node(TURTLE_), turtle(0), graphNode(0), shapes(0) {}
		TurtleNode(Turtle *turtle_, GraphNodeP graphNode_);

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();
};

#define TurtleNode_included
