//___________________________________________________________________
//
//                          IO Header
//___________________________________________________________________

extern Function
	lPortOut, lPortIn,//, lPortInt16In, lPortIntIn,
	lsetPortBit, lclearPortBit, lnotPortBit, lgetPortBit,
	lleftPortShift, lrightPortShift;

typedef void (WINAPI *PORTOUT) (int16 Port, char Data);
typedef void (WINAPI *PORTWORDOUT)(int16 Port, int16 Data);
typedef void (WINAPI *PORTDWORDOUT)(int16 Port, int Data);
typedef char (WINAPI *PORTIN) (int16 Port);
typedef int16 (WINAPI *PORTWORDIN)(int16 Port);
typedef int (WINAPI *PORTDWORDIN)(int16 Port);
typedef void (WINAPI *SETPORTBIT)(int16 Port, char Bit);
typedef void (WINAPI *CLEARPORTBIT)(int16 Port, char Bit);
typedef void (WINAPI *NOTPORTBIT)(int16 Port, char Bit);
typedef int16 (WINAPI *GETPORTBIT)(int16 Port, char Bit);
typedef int16 (WINAPI *RIGHTPORTSHIFT)(int16 Port, int16 Val);
typedef int16 (WINAPI *LEFTPORTSHIFT)(int16 Port, int16 Val);
typedef int16 (WINAPI *ISDRIVERINSTALLED)();

extern PORTOUT PortOut;
extern PORTWORDOUT PortWordOut;
extern PORTDWORDOUT PortDWordOut;
extern PORTIN PortIn;
extern PORTWORDIN PortWordIn;
extern PORTDWORDIN PortDWordIn;
extern SETPORTBIT SetPortBit;
extern CLEARPORTBIT ClearPortBit;
extern NOTPORTBIT NotPortBit;
extern GETPORTBIT GetPortBit;
extern RIGHTPORTSHIFT RightPortShift;
extern LEFTPORTSHIFT LeftPortShift;
extern ISDRIVERINSTALLED IsDriverInstalled;

extern bool LoadIODLL();
extern void UnloadIODLL();
